/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

void RenderDialog::init(const RenderWidget* _rw)
{
    const TriMesh* m = &_rw->mesh();

    colorModeComboBox->insertStringList(m->vertex_color_mode_names());
    colorModeComboBox->setCurrentItem(m->current_vertex_color_mode());
    connect(colorModeComboBox, SIGNAL(activated(int)), _rw, SLOT(setVertexColorMode(int)));
    connect(_rw, SIGNAL(vertexColorModeChanged(int)), _rw, SLOT(setVertexColorMode(int)));

    connect(drawVertexNormalsCheckBox, SIGNAL(toggled(bool)), _rw, SLOT(setDrawVertexNormals(bool)));
    connect(drawFaceNormalsCheckBox, SIGNAL(toggled(bool)), _rw, SLOT(setDrawFaceNormals(bool)));
}


void RenderDialog::setVertexColorMode(int _id)
{
	colorModeComboBox->setCurrentItem(_id);
}
