/*
 *  sparsematrix.h
 * 
 *  Authors: Michael Sauter
 *
 *  Content: class for a sparse matrix data structure
 *
 */

#ifndef _SPARSE_MATRIX_H_
#define _SPARSE_MATRIX_H_

#include <vector>


class SparseMatrix
{
    // structure for representation of sparse matrix entries
    struct Mat_Entry
    {
        int row;        // row index
        int col;        // col index
        double val;     // value
    };

    typedef std::vector<Mat_Entry>    sparse_mat_type;

public:
    SparseMatrix(void);
	~SparseMatrix(void);

public:
    void insert(int row, int col, double val);
    void mul_vec(int size, double *x, double *res);
    void mul_mat(int size_n, int size_m, double *X, double *Res);
    void trans_mul_vec(int size, double *x, double *res);
    void trans_mul_mat(int size_n, int size_m, double *X, double *Res);

private:
    sparse_mat_type     matrix_;     // the sparse matrix
};


#endif      // _SPARSE_MATRIX_H_
