//=============================================================================
//                                                                            
//                               OpenMesh                                     
//        Copyright (C) 2003 by Computer Graphics Group, RWTH Aachen          
//                           www.openmesh.org                                 
//                                                                            
//-----------------------------------------------------------------------------
//                                                                            
//                                License                                     
//                                                                            
//   This library is free software; you can redistribute it and/or modify it 
//   under the terms of the GNU Library General Public License as published  
//   by the Free Software Foundation, version 2.                             
//                                                                             
//   This library is distributed in the hope that it will be useful, but       
//   WITHOUT ANY WARRANTY; without even the implied warranty of                
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         
//   Library General Public License for more details.                          
//                                                                            
//   You should have received a copy of the GNU Library General Public         
//   License along with this library; if not, write to the Free Software       
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 
//                                                                            
//-----------------------------------------------------------------------------
//                                                                            
//   $Revision: 1.1.1.1 $
//   $Date: 2003/10/14 14:11:34 $
//                                                                            
//=============================================================================


//=============================================================================
//
//  Mesh Handle Concept
//
//=============================================================================


#error this file is for documentation purposes only


//== NAMESPACES ===============================================================


namespace OpenMesh {
namespace Concepts { 


//== CLASS DEFINITION =========================================================


/** \ingroup mesh_concepts_group
    Concept for mesh handles, i.e. handles to the different mesh items.
    This interface must be provided by every handle implementation.
    The template parameter specifies what type this will be a handle for.
*/
template <class T> class HandleT
{ 
public:
  
  /// Default constructor. Handles \b must be invalid after construction.
  explicit HandleT();
  /// Is the handle valid?
  bool is_valid() const;
  /// Are 2 handles equal?
  bool operator==(const HandleConecpt& _rhs) const;
  /// Are 2 handles not equal?
  bool operator!=(const HandleConecpt& _rhs) const;
  /// Comparison
  bool operator<(const HandleConecpt& _rhs) const;
};



//=============================================================================
} // namespace Conecpts
} // namespace OpenMesh
//=============================================================================
